﻿Imports System.Drawing.Drawing2D

Class DisplayBands

    Private m_fillBrush As LinearGradientBrush
    Private m_TextBrush As Brush = Brushes.Azure



    Private Function CreateFillBrush(ByVal pbox As PictureBox, _
                                     ByVal direction As LinearGradientMode) As LinearGradientBrush
        CreateFillBrush = New LinearGradientBrush(pbox.ClientRectangle, _
                                                  Color.Black, _
                                                  Color.Black, _
                                                  direction)
        Dim myBlend As ColorBlend = New ColorBlend()
        myBlend.Colors = New Color() {Color.FromArgb(255, 0, 0), _
                                      Color.FromArgb(255, 230, 0), _
                                      Color.FromArgb(250, 250, 0), _
                                      Color.FromArgb(230, 230, 0), _
                                      Color.FromArgb(0, 120, 0)}
        myBlend.Positions = New Single() {0.0F, 0.4F, 0.5F, 0.6F, 1.0F}
        CreateFillBrush.InterpolationColors = myBlend
    End Function

    Friend Sub Initialize(ByVal pbox As PictureBox)
        CloseAll()
        m_fillBrush = CreateFillBrush(pbox, LinearGradientMode.Vertical)
    End Sub

    Friend Sub CloseAll()

    End Sub

    Friend Sub Update(ByVal pbox As PictureBox, _
                      ByVal fmin As Single, _
                      ByVal fmax As Single, _
                      ByVal dbmin As Single, _
                      ByVal dbmax As Single, _
                      ByVal xlog As Boolean, _
                      ByVal ylog As Boolean, _
                      ByVal speed As Single, _
                      ByVal NumBands As Int32)

        InitPictureboxImage(pbox)

        Dim ddx As Int32 = pbox.Image.Width - 5
        Dim ddy As Int32 = pbox.Image.Height

        Dim g As Graphics = Graphics.FromImage(pbox.Image)
        g.Clear(Color.FromArgb(60, 60, 60))

        If dbmin >= dbmax Or fmin >= fmax Or fmax > SamplesPerSec \ 2 Then
            g.DrawString("Invalid params", New Font("Arial", 11), m_TextBrush, 10, 10)
            pbox.Invalidate()
            Return
        End If

        BandsExtractor2.FhtBuffer = Fht1.OutputBuffer
        BandsExtractor2.ExtractBands(NumBands, fmin, fmax, dbmin, dbmax, xlog, ylog, SamplesPerSec, speed)
        If BandsExtractor1.BandsBuffer Is Nothing Then Return

        Dim x As Single
        Dim bandspacing As Single = CSng(ddx / NumBands)
        Dim bandsize As Single = bandspacing - 1
        If bandspacing < 4 Then bandsize = bandspacing
        For b As Int32 = 0 To NumBands - 1
            x = b * bandspacing
            g.FillRectangle(m_fillBrush, x + 2, ddy * (1 - BandsExtractor2.BandsBuffer(b)), bandsize, ddy)
        Next

        pbox.Invalidate()
    End Sub

End Class
