﻿Public Class FIFO

    Private m_FifoLength As Int32
    Private m_WriteIndex As Int32
    Private m_ReadIndex As Int32
    Private m_CircularBuffer() As Single

    Friend Sub New(ByVal FifoLength As Int32)
        m_FifoLength = FifoLength
        ReDim m_CircularBuffer(m_FifoLength - 1)
        Flush()
    End Sub

    Friend Sub Flush()
        m_ReadIndex = 0
        m_WriteIndex = 0
    End Sub

    Friend Function GetWriteIndex() As Int32
        Return m_WriteIndex
    End Function

    Friend Sub SetReadIndex(ByVal position As Int32)
        m_ReadIndex = position
        While m_ReadIndex < 0
            m_ReadIndex += m_FifoLength
        End While
    End Sub

    Private zero As Single
    Private v As Single
    Friend Sub AddArray(ByVal Values() As Int16)
        'SyncLock Me
        Dim k As Single = -InputTrimmer / 65536.0F
        If RemoveDC Then
            For i As Int32 = 0 To Values.Length - 1
                v = Values(i) * k - zero
                zero += v / 10000.0F
                AddElement(v)
            Next
        Else
            For i As Int32 = 0 To Values.Length - 1
                AddElement(Values(i) * k)
            Next
        End If
        'End SyncLock
    End Sub

    Friend Sub GetArray(ByRef Values() As Single)
        'SyncLock Me
        For i As Int32 = 0 To Values.Length - 1
            Values(i) = GetElement()
        Next
        'End SyncLock
    End Sub

    Friend Sub AddElement(ByVal Value As Single)
        'SyncLock Me
        m_CircularBuffer(m_WriteIndex) = Value
        m_WriteIndex += 1
        If m_WriteIndex >= m_FifoLength Then m_WriteIndex = 0
        'End SyncLock
    End Sub

    Friend Function GetElement() As Single
        'SyncLock Me
        GetElement = m_CircularBuffer(m_ReadIndex)
        m_ReadIndex += 1
        If m_ReadIndex >= m_FifoLength Then m_ReadIndex = 0
        'End SyncLock
    End Function

    Friend Function GetElement(ByVal Index As Int32) As Single
        'SyncLock Me
        While Index < 0 : Index += m_FifoLength : End While
        While Index >= m_FifoLength : Index -= m_FifoLength : End While
        Return m_CircularBuffer(Index)
        'End SyncLock
    End Function

End Class
