﻿' -------------------------------
' TODO - MAIN TODO LIST
' -------------------------------
' 

Public Class Form1

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        EventsAreEnabled = False
        Text = AppTitleAndVersion("")
        ' --------------------------------------------------------
        Combo_InitFromEnum(cmb_Spec_Window, GetType(FHT.WindowTypes))
        cmb_Spec_Window.SelectedIndex = 15
        cmb_FhtSamples.SelectedIndex = 2
        ' --------------------------------------------------------
        Load_INI()
        ' --------------------------------------------------------
        SetInputParams()
        SetFhtSamples()
        SetHarmonicsParams()
        SetScopeParams()
        SetBandsParams()
        SetSpectrumParams()
        ' -------------------------------------------------------- 
        FHT_Initialize()
        SetSpectrumWindowType()
        DisplayScope1.Initialize(pbox_Scope)
        DisplaySpectrum1.Initialize(pbox_Spectrum)
        DisplayBands1.Initialize(pbox_SpectrumBars)
        ' -------------------------------------------------------- TIMER START
        Timer1.Interval = 500
        Timer1.Start()
        Timer2.Interval = 50
        Timer2.Start()
        ' --------------------------------------------------------
        FillAudioInDevicesCombo()
        AudioReaderStart(SelectedAudioIn)
        ' -------------------------------------------------------- CPU Affinity test
        'Dim Proc As Process = Process.GetCurrentProcess()
        'For i As Int32 = 0 To Proc.Threads.Count
        '    Dim Thread As ProcessThread = Proc.Threads(0)
        '    Dim AffinityMask As Int32 = 2  ' use only flagged processors, despite availability
        '    Thread.ProcessorAffinity = CType(AffinityMask, IntPtr)
        'Next
        ' ----------------------------------------------------------- 
        ' Do not use PriorityClass "Above normal" or "Real time"
        '  because this could degrade the AccurateTimer
        ' -----------------------------------------------------------
        ' Dim Proc As Process = Process.GetCurrentProcess()
        ' Proc.PriorityClass = ProcessPriorityClass.Normal
        ' -----------------------------------------------------------
        EventsAreEnabled = True
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        AudioReaderStop()
        DisplayScope1.CloseAll()
        DisplayBands1.CloseAll()
        DisplaySpectrum1.CloseAll()
        Save_INI()
    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Not EventsAreEnabled Then Return
        UpdateDisplay()
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub


    ' ===================================================================================================
    '  USER PARAMS 
    ' ===================================================================================================

    Private Sub SaveParamsOnLostFocus(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                Handles txt_InputTrimmer.LostFocus, _
                                                                        txt_BaseFreq.LostFocus, _
                                                                        txt_DeltaFreq.LostFocus, _
                                                                        txt_HarmonicsOutSlot.LostFocus, _
                                                                        txt_ThdOutSlot.LostFocus, _
                                                                        chk_RemoveDC.LostFocus, _
                                                                        tbar_ScopeVoltage.LostFocus, _
                                                                        tbar_ScopeTime.LostFocus, _
                                                                        chk_ScopeNeg.LostFocus, _
                                                                        chk_ScopeTrig.LostFocus, _
                                                                        txt_BandsCount.LostFocus, _
                                                                        txt_BandsOutSlot.LostFocus, _
                                                                        txt_SpecMaxDb.LostFocus, _
                                                                        txt_SpecMinDb.LostFocus, _
                                                                        txt_SpecMaxFreq.LostFocus, _
                                                                        txt_SpecMinFreq.LostFocus, _
                                                                        txt_SpecSpeed.LostFocus, _
                                                                        chk_SpecLogX.LostFocus, _
                                                                        chk_SpecLogY.LostFocus, _
                                                                        cmb_Spec_Window.LostFocus
        If Not EventsAreEnabled Then Return
        Save_INI()
    End Sub

    Private Sub InputParams_Changed(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                Handles txt_InputTrimmer.TextChanged
        If Not EventsAreEnabled Then Return
        SetInputParams()
    End Sub
    Private Sub SetInputParams()
        InputTrimmer = CSng(txt_InputTrimmer.NumericValue)
    End Sub

    ' ===================================================================================================
    '  SELECT AUDIO INPUT 
    ' ===================================================================================================
    Friend SelectedAudioIn As Int32 = 0
    Private Sub cmb_AudioInDevices_DropDown(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioInDevices.DropDown
        cmb_AudioInDevices.ItemHeight = 16
        FillAudioInDevicesCombo()
    End Sub
    Private Sub cmb_AudioInDevices_DropDownClosed(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmb_AudioInDevices.DropDownClosed
        cmb_AudioInDevices.ItemHeight = 11
        SelectedAudioIn = cmb_AudioInDevices.SelectedIndex
        AudioReaderStart(SelectedAudioIn)
    End Sub
    Private Sub FillAudioInDevicesCombo()
        Dim sa As String() = WaveNative.GetInputDevicesNames
        If sa.Length = 0 Then ReDim sa(0)
        cmb_AudioInDevices.Items.Clear()
        For i As Int32 = 0 To sa.Length - 1
            cmb_AudioInDevices.Items.Add(ExtractDeviceName(sa(i)))
        Next
        Combo_SetIndex(cmb_AudioInDevices, SelectedAudioIn)
    End Sub

    ' ===================================================================================================
    '  AUDIO IN HELPERS
    ' ===================================================================================================
    Private Sub btn_AudioInputs_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) _
                                                                        Handles btn_AudioInputs.ClickButtonArea
        Shell("control mmsys.cpl,,1", AppWinStyle.NormalFocus)
    End Sub
    Private Function ExtractDeviceName(ByVal s As String) As String
        If s = Nothing Then Return ""
        Dim i As Int32 = InStr(s, "(") - 1
        If i > 1 Then s = s.Remove(i)
        Return s.Trim
    End Function



    Private Sub txt_Harmonics_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles txt_BaseFreq.TextChanged, _
                                                                                                       txt_DeltaFreq.TextChanged, _
                                                                                                       txt_HarmonicsOutSlot.TextChanged, _
                                                                                                       txt_ThdOutSlot.TextChanged
        If Not EventsAreEnabled Then Return
        SetHarmonicsParams()
    End Sub
    Private Sub SetHarmonicsParams()
        HarmonicsBaseFreq = CSng(txt_BaseFreq.NumericValue)
        HarmonicsDeltaFreq = CSng(txt_DeltaFreq.NumericValue)
        HarmonicsOutputSlot = txt_HarmonicsOutSlot.NumericValueInteger
        ThdOutputSlot = txt_ThdOutSlot.NumericValueInteger
    End Sub

    Private Sub ScopeParams_Changed(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                                    Handles chk_RemoveDC.CheckedChanged, _
                                                                            chk_ScopeNeg.CheckedChanged, _
                                                                            chk_ScopeTrig.CheckedChanged, _
                                                                            tbar_ScopeVoltage.Scroll, _
                                                                            tbar_ScopeTime.Scroll
        If Not EventsAreEnabled Then Return
        SetScopeParams()
    End Sub
    Private Sub SetScopeParams()
        RemoveDC = chk_RemoveDC.Checked
        DisplayScope1.SetNegative(chk_ScopeNeg.Checked)
        DisplayScope1.Settrig(chk_ScopeTrig.Checked)
        DisplayScope1.SetVoltage(VoltageFromTrackBar(tbar_ScopeVoltage.Value))
        DisplayScope1.SetTime(TimeFromTrackBar(tbar_ScopeTime.Value))
    End Sub
    Private Function VoltageFromTrackBar(ByVal n As Int32) As Single
        Select Case n
            Case 0 : Return 1000
            Case 1 : Return 500
            Case 2 : Return 250
            Case 3 : Return 200
            Case 4 : Return 100
            Case 5 : Return 50
            Case 6 : Return 25
            Case 7 : Return 20
            Case 8 : Return 10
            Case 9 : Return 5
            Case 10 : Return 2.5
            Case 11 : Return 2
            Case 12 : Return 1
        End Select
    End Function
    Private Function TimeFromTrackBar(ByVal n As Int32) As Single
        Select Case n
            Case 0 : Return 100
            Case 1 : Return 50
            Case 2 : Return 20
            Case 3 : Return 10
            Case 4 : Return 5
            Case 5 : Return 2
            Case 6 : Return 1
            Case 7 : Return 0.5
            Case 8 : Return 0.2
            Case 9 : Return 0.1
        End Select
    End Function

    Private Sub BandsParamsChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                       Handles txt_BandsCount.TextChanged, _
                                                               txt_BandsOutSlot.TextChanged
        If Not EventsAreEnabled Then Return
        SetBandsParams()
        UpdateDisplay()
        Refresh()
    End Sub
    Private Sub SetBandsParams()
        BandsCount = txt_BandsCount.NumericValueInteger
        BandsOutputSlot = txt_BandsOutSlot.NumericValueInteger
    End Sub

    Private Sub SpectrumParamsChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) _
                                                           Handles txt_SpecMaxDb.TextChanged, _
                                                                   txt_SpecMinDb.TextChanged, _
                                                                   txt_SpecMaxFreq.TextChanged, _
                                                                   txt_SpecMinFreq.TextChanged, _
                                                                   txt_SpecSpeed.TextChanged, _
                                                                   chk_SpecLogX.CheckedChanged, _
                                                                   chk_SpecLogY.CheckedChanged
        If Not EventsAreEnabled Then Return
        SetSpectrumParams()
        UpdateDisplay()
        Refresh()
    End Sub
    Private Sub SetSpectrumParams()
        SpecMinFreq = CSng(txt_SpecMinFreq.NumericValue)
        SpecMaxFreq = CSng(txt_SpecMaxFreq.NumericValue)
        SpecMinDb = CSng(txt_SpecMinDb.NumericValue)
        SpecMaxDb = CSng(txt_SpecMaxDb.NumericValue)
        SpecSpeed = CSng(txt_SpecSpeed.NumericValue / 100.0)
        SpecLogX = chk_SpecLogX.Checked
        SpecLogY = chk_SpecLogY.Checked
    End Sub


    Private Sub AllCombo_DropDown(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Spec_Window.DropDown, _
                                                                                               cmb_FhtSamples.DropDown
        CType(sender, ComboBox).ItemHeight = 16
    End Sub
    Private Sub AllCombo_DropDownClosed(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmb_Spec_Window.DropDownClosed, _
                                                                                                     cmb_FhtSamples.DropDownClosed
        CType(sender, ComboBox).ItemHeight = 12
    End Sub

    Private Sub cmb_Spec_Window_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                    Handles cmb_Spec_Window.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        SetSpectrumWindowType()
        GroupBox_Scope.Focus()
    End Sub
    Private SpectrumWindowType As FHT.WindowTypes
    Private Sub SetSpectrumWindowType()
        SpectrumWindowType = CType(cmb_Spec_Window.SelectedIndex, FHT.WindowTypes)
    End Sub

    Private Sub cmb_FhtSamples_SelectionChangeCommitted(ByVal sender As Object, ByVal e As System.EventArgs) _
                                                                    Handles cmb_FhtSamples.SelectionChangeCommitted
        If Not EventsAreEnabled Then Return
        SetFhtSamples()
        FHT_Initialize()
        GroupBox_Scope.Focus()
    End Sub
    Private Sub SetFhtSamples()
        FHT_Samples = CInt(Val(cmb_FhtSamples.Text.Trim.Split(" "c)(0)))
    End Sub


    ' ===================================================================================================
    '  TIMER - UPDATE FHT and EXTRACT HARMONICS
    ' ===================================================================================================
    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If Not EventsAreEnabled Then Return
        UpdateFHT()
        HarmonicsExtractor1.ExtractHarmonics(Fht1.OutputBuffer, _
                                             SamplesPerSec, _
                                             HarmonicsBaseFreq, _
                                             HarmonicsDeltaFreq)
        WriteArmonicsToSlots()
        WriteThdToSlot()
    End Sub

    Private Sub UpdateFHT()
        'ReportString = ""
        ' ----------------------------------------------------- 
        FHT_Execute(SpecMinFreq, _
                    SpecMaxFreq, _
                    SpecMinDb, _
                    SpecMaxDb, _
                    SpecLogX, _
                    SpecLogY, _
                    SpecSpeed, _
                    SpectrumWindowType)
        ' -----------------------------------------------------
        'If ReportString <> "" Then Text = ReportString
    End Sub

    Private Sub WriteArmonicsToSlots()
        ' ----------------------------------------------------------------------------------- test print
        Dim s As String = ""
        'For i As Int32 = 0 To HarmonicsExtractor1.Harmonics.Length - 1
        '    s += HarmonicsExtractor1.Harmonics(i).ToString("0.000") + " "
        'Next
        ''Text = s + "    " + HarmonicsExtractor1.HarmonicDistortion.ToString("0.0") + "%"
        'Text = s + "    " + HarmonicsExtractor1.HarmonicDistortion.ToString("0") + "%"
        ' -----------------------------------------------------------------------------------
        If HarmonicsOutputSlot >= 0 Then
            For i As Int32 = 0 To HarmonicsExtractor1.Harmonics.Length - 1
                Slots.WriteSlot(HarmonicsOutputSlot + i, HarmonicsExtractor1.Harmonics(i))
            Next
        End If
    End Sub

    Private Sub WriteThdToSlot()
        If ThdOutputSlot >= 0 Then
            Slots.WriteSlot(ThdOutputSlot, HarmonicsExtractor1.HarmonicDistortion)
        End If
    End Sub

    ' ===================================================================================================
    '  TIMER - UPDATE DISPLAY and WRITE OUTPUT SLOTS
    ' ===================================================================================================

    Private Sub Timer2_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer2.Tick
        UpdateDisplay()
        WriteBandOutSlots()
    End Sub

    Private Sub UpdateDisplay()
        ' ----------------------------------------------------- 
        DisplayScope1.Update(pbox_Scope)
        ' ----------------------------------------------------- 
        DisplaySpectrum1.Update(pbox_Spectrum, _
                         SpecMinFreq, _
                         SpecMaxFreq, _
                         SpecMinDb, _
                         SpecMaxDb, _
                         SpecLogX, _
                         SpecLogY, _
                         SpecSpeed)
        ' ----------------------------------------------------- 
        DisplayBands1.Update(pbox_SpectrumBars, _
                             SpecMinFreq, _
                             SpecMaxFreq, _
                             SpecMinDb, _
                             SpecMaxDb, _
                             SpecLogX, _
                             SpecLogY, _
                             SpecSpeed, _
                             BandsCount)
    End Sub

    Private Sub WriteBandOutSlots()
        If BandsOutputSlot < 0 Then Return
        If BandsExtractor2.BandsBuffer Is Nothing Then Return
        For i As Int32 = 0 To BandsExtractor2.BandsBuffer.Length - 1
            Slots.WriteSlot(BandsOutputSlot + i, BandsExtractor2.GetBandValueInVoltOrDecibel(i))
        Next
    End Sub


End Class
